searchNodes=[{"doc":"Generate Elixir code from .proto files.Example: mix protox.generate --output-path=lib/message.ex --include-path=. message.protoThe generated file will be usable in any project as long as protox is declared in the dependencies (the generated file still needs functions from the protox runtime).You can use the --namespace option to prepend a namespace to all generated modules.If you have large protobuf files, you can use the --multiple-files option to generate one file per module.Finally, you can pass the option --keep-unknown-fields=false to remove support of unknown fields.","ref":"Mix.Tasks.Protox.Generate.html","title":"Mix.Tasks.Protox.Generate","type":"task"},{"doc":"Use this module to generate the Elixir modules corresponding to a set of protobuf definitions.ExamplesFrom a set of files:defmodule Foo do use Protox, files: [ &quot;./defs/foo.proto&quot;, &quot;./defs/bar.proto&quot;, &quot;./defs/baz/fiz.proto&quot;, ] endFrom a string:defmodule Bar do use Protox, schema: &quot;&quot;&quot; syntax = &quot;proto3&quot;; message Baz { } message Foo { map&lt;int32, Baz&gt; b = 2; } &quot;&quot;&quot; endThe generated modules respect the package declaration. For instance, in the above example, both the Fiz.Baz and Fiz.Foo modules will be generated.See README for detailed instructions.","ref":"Protox.html","title":"Protox","type":"module"},{"doc":"","ref":"Protox.html#generate_module_code/6","title":"Protox.generate_module_code/6","type":"function"},{"doc":"Default values of Protocol Buffers types.Note that generated structs contain a default/1 function to return the default value of a field using its name.","ref":"Protox.Default.html","title":"Protox.Default","type":"module"},{"doc":"Returns the default value of a Protocol Buffer type specified with an atom.Examplesiex&gt; Protox.Default.default(:bool) false iex&gt; Protox.Default.default(:string) &quot;&quot;","ref":"Protox.Default.html#default/1","title":"Protox.Default.default/1","type":"function"},{"doc":"This module contains the functions necessary to encode protobuf messages.","ref":"Protox.Encode.html","title":"Protox.Encode","type":"module"},{"doc":"Encode a protobuf message into IO data.Examplemsg = %Fiz.Foo{a: 3, b: %{1 =&gt; %Fiz.Baz{}}} {:ok, iodata} = Protox.Encode.encode(msg)","ref":"Protox.Encode.html#encode/1","title":"Protox.Encode.encode/1","type":"function"},{"doc":"Throwing version of encode/1.","ref":"Protox.Encode.html#encode!/1","title":"Protox.Encode.encode!/1","type":"function"},{"doc":"This module provides functions to work with messages.","ref":"Protox.Message.html","title":"Protox.Message","type":"module"},{"doc":"Singular fields of msg will be overwritten, if specified in from, except for embedded messages which will be merged. Repeated fields will be concatenated.Note that &quot;specified&quot; has a different meaning in protobuf 2 and 3:2: if the singular field from from is nil, the value from msg is kept3: if the singular field from from is set to the default value, the value from msg is kept. This behaviour matches the C++ reference implementation behaviour.msg and from must be of the same type; oreither msg or from is nil: the non-nil message is returned; orboth are nil: nil is returnedExampleiex&gt; r1 = %Protobuf2{a: 0, s: :ONE} iex&gt; r2 = %Protobuf2{a: nil, s: :TWO} iex&gt; Protox.Message.merge(r1, r2) %Protobuf2{a: 0, s: :TWO} iex&gt; Protox.Message.merge(r2, r1) %Protobuf2{a: 0, s: :ONE}","ref":"Protox.Message.html#merge/2","title":"Protox.Message.merge/2","type":"function"},{"doc":"This module describes types that define a protobuf message.See https://developers.google.com/protocol-buffers/docs/encoding#structure.","ref":"Protox.Types.html","title":"Protox.Types","type":"module"},{"doc":"This type give more details on how a field is encoded.","ref":"Protox.Types.html#t:kind/0","title":"Protox.Types.kind/0","type":"type"},{"doc":"All types that can be used as a key in map field.","ref":"Protox.Types.html#t:map_key_type/0","title":"Protox.Types.map_key_type/0","type":"type"},{"doc":"The wire type of a field: it tells how a field is encoded (32 or 64 bits scalar, repeated or variable-length integer).","ref":"Protox.Types.html#t:tag/0","title":"Protox.Types.tag/0","type":"type"},{"doc":"All types that can be stored in a protobuf message.","ref":"Protox.Types.html#t:type/0","title":"Protox.Types.type/0","type":"type"},{"doc":"32 bits scalar.","ref":"Protox.Types.html#t:wire_32bits/0","title":"Protox.Types.wire_32bits/0","type":"type"},{"doc":"64 bits scalar.","ref":"Protox.Types.html#t:wire_64bits/0","title":"Protox.Types.wire_64bits/0","type":"type"},{"doc":"Repeated field.","ref":"Protox.Types.html#t:wire_delimited/0","title":"Protox.Types.wire_delimited/0","type":"type"},{"doc":"Variable length integer.","ref":"Protox.Types.html#t:wire_varint/0","title":"Protox.Types.wire_varint/0","type":"type"},{"doc":"This error is thrown when a data could not be decoded.","ref":"Protox.DecodingError.html","title":"Protox.DecodingError","type":"exception"},{"doc":"","ref":"Protox.DecodingError.html#new/2","title":"Protox.DecodingError.new/2","type":"function"},{"doc":"This error is thrown when decoding data with a field which tag is 0.","ref":"Protox.IllegalTagError.html","title":"Protox.IllegalTagError","type":"exception"},{"doc":"This error is thrown when encoding or decoding a Protobuf 2 message with unset required fields (that is, that have the value nil).","ref":"Protox.RequiredFieldsError.html","title":"Protox.RequiredFieldsError","type":"exception"},{"doc":"","ref":"Protox.RequiredFieldsError.html#new/1","title":"Protox.RequiredFieldsError.new/1","type":"function"},{"doc":"Protox Protox is an Elixir library to work with Google's Protocol Buffers (aka protobuf), versions 2 and 3.The primary objective of protox is reliability: it uses property based testing and has a near 100% code coverage. Also, using mutation testing with the invaluable help of Muzak pro, the quality of the protox test suite has been validated. Therefore, protox passes all the tests of the conformance checker provided by Google. See Conformance section for more information.This library is easy to use: you just point to the *.proto files or give the schema to the Protox macro, no need to generate any file! However, should you need to generate files, a mix task is available (see Files generation).Protox provides a full-blown Elixir experience with protobuf messages. For instance, given the following protobuf msg.proto file:syntax = &quot;proto3&quot;; message Msg{ int32 a = 1; map&lt;int32, string&gt; b = 2; }You can interact with Msg as if it were a native Elixir structure. For example, note how the map b is translated into a map:iex&gt; msg = %Msg{a: 42, b: %{1 =&gt; &quot;a map entry&quot;}} iex&gt; {:ok, iodata} = Protox.Encode.encode(msg) # or Msg.encode(msg) ... iex&gt; binary = # read binary from a socket, a file, etc. iex&gt; {:ok, msg} = Msg.decode(binary)You can find here a more involved example with most types.","ref":"readme.html","title":"Protox","type":"extras"},{"doc":"ProtoxTable of contentsPrerequisitesInstallationUsage with a textual descriptionUsage with filesEncodeDecodePackages and namespacesPackagesPrepend namespacesSpecify import pathUnknown fieldsUnsupported featuresImplementation choicesGenerated code referenceFiles generationConformanceTypes mappingBenchmarksCredits","ref":"readme.html#table-of-contents","title":"Protox - Table of contents","type":"extras"},{"doc":"Protox uses Google's protoc (&gt;= 3.0) to parse .proto files. It must be available in $PATH. You can download it here or you can install it with your favorite package manager (brew install protobuf, apt install protobuf-compiler, etc.).This dependency is only required at compile-time.","ref":"readme.html#prerequisites","title":"Protox - Prerequisites","type":"extras"},{"doc":"Add :protox to your list of dependencies in mix.exs:def deps do [{:protox, &quot;~&gt; 1.3&quot;}] end","ref":"readme.html#installation","title":"Protox - Installation","type":"extras"},{"doc":"Here's how to generate the modules from a textual description:defmodule Bar do use Protox, schema: &quot;&quot;&quot; syntax = &quot;proto3&quot;; package fiz; message Baz { } message Foo { int32 a = 1; map&lt;int32, Baz&gt; b = 2; } &quot;&quot;&quot; endThis example will generate two modules: Fiz.Baz and Fiz.Foo. Note that the module in which the Protox macro is called is completely ignored and therefore does not appear in the names of the generated modules.","ref":"readme.html#usage-with-a-textual-description","title":"Protox - Usage with a textual description","type":"extras"},{"doc":"Here's how to generate the modules from a set of files:defmodule Foo do use Protox, files: [ &quot;./defs/foo.proto&quot;, &quot;./defs/bar.proto&quot;, &quot;./defs/baz/fiz.proto&quot;, ] endAgain, the module in which the Protox macro is called is completely ignored.","ref":"readme.html#usage-with-files","title":"Protox - Usage with files","type":"extras"},{"doc":"Here's how to create and encode a new message:iex&gt; msg = %Fiz.Foo{a: 3, b: %{1 =&gt; %Fiz.Baz{}}} iex&gt; {:ok, iodata} = Protox.Encode.encode(msg)Or, with throwing style:iex&gt; iodata = Protox.Encode.encode!(msg)It's also possible to call encode/1 and encode!/1 directly on the generated structures:iex&gt; {:ok, iodata} = Fiz.Foo.encode(msg)Note that encode/1 returns an IO data, not a binary, for efficiency reasons. Such IO data can be used directly with files or sockets write operations, and therefore you don't need to transform them:iex&gt; {:ok, iodata} = Protox.Encode.encode(%Fiz.Foo{a: 3, b: %{1 =&gt; %Fiz.Baz{}}}) [[[], &lt;&lt;18&gt;&gt;, &lt;&lt;4&gt;&gt;, &quot;\\b&quot;, &lt;&lt;1&gt;&gt;, &lt;&lt;18&gt;&gt;, &lt;&lt;0&gt;&gt;], &quot;\\b&quot;, &lt;&lt;3&gt;&gt;] iex&gt; {:ok, file} = File.open(&quot;msg.bin&quot;, [:write]) {:ok, #PID&lt;0.1023.0&gt;} iex&gt; IO.binwrite(file, iodata) :okHowever, you can use :binary.list_to_bin/1 or IO.iodata_to_binary to get a binary should the need arises:iex&gt; %Fiz.Foo{a: 3, b: %{1 =&gt; %Fiz.Baz{}}} |&gt; Protox.Encode.encode!() |&gt; :binary.list_to_bin() &lt;&lt;8, 3, 18, 4, 8, 1, 18, 0&gt;&gt;","ref":"readme.html#encode","title":"Protox - Encode","type":"extras"},{"doc":"Here's how to decode a message from a binary:iex&gt; {:ok, msg} = Fiz.Foo.decode(&lt;&lt;8, 3, 18, 4, 8, 1, 18, 0&gt;&gt;)Or, with throwing style:iex&gt; msg = Fiz.Foo.decode!(&lt;&lt;8, 3, 18, 4, 8, 1, 18, 0&gt;&gt;)","ref":"readme.html#decode","title":"Protox - Decode","type":"extras"},{"doc":"PackagesProtobuf provides a package directive:syntax = &quot;proto3&quot;; package abc.def; message Baz { }Modules generated by protox will include this package declaration. Thus, the example above will be translated to Abc.Def.Baz (note the camelization of package abc.def to Abc.Def).Prepend namespacesIn addition, protox provides the possibility to prepend a namespace to all generated modules:defmodule Bar do use Protox, schema: &quot;&quot;&quot; syntax = &quot;proto3&quot;; package abc; message Msg { int32 a = 1; } &quot;&quot;&quot;, namespace: MyApp endIn this example, the module MyApp.Abc.Msg is generated:iex&gt; msg = %MyApp.Msg{a: 42}It's useful to make the generated code appear as being part of your code structure.","ref":"readme.html#packages-and-namespaces","title":"Protox - Packages and  namespaces","type":"extras"},{"doc":"An import path can be specified using the path: option that specifies the directory in which to search for import:defmodule Baz do use Protox, files: [ &quot;./defs/prefix/foo.proto&quot;, &quot;./defs/prefix/bar/bar.proto&quot;, ], path: &quot;./defs&quot; endIt corresponds to the -I option of protoc.","ref":"readme.html#specify-import-path","title":"Protox - Specify import path","type":"extras"},{"doc":"Unknown fields are fields that are present on the wire but which do not correspond to an entry in the protobuf definition. Typically, it occurs when the sender has a newer version of the protobuf definition. It makes possible to have backward compatibility as the receiver with an old version of the protobuf definition will still be able to decode old fields.When unknown fields are encountered at decoding time, they are kept in the decoded message. It's possible to access them with the function unknown_fields/1 defined with the message.iex&gt; msg = Msg.decode!(&lt;&lt;8, 42, 42, 4, 121, 97, 121, 101, 136, 241, 4, 83&gt;&gt;) %Msg{a: 42, b: &quot;&quot;, z: -42, __uf__: [{5, 2, &lt;&lt;121, 97, 121, 101&gt;&gt;}]} iex&gt; Msg.unknown_fields(msg) [{5, 2, &lt;&lt;121, 97, 121, 101&gt;&gt;}]You must always use unknown_fields/1 as the name of the field (e.g. __uf__ in the above example) is generated at compile-time to avoid collision with the actual fields of the Protobuf message. This function returns a list of tuples {tag, wire_type, bytes}. For more information, please see protobuf encoding guide.When you encode a message that contains unknown fields, they will be reencoded in the serialized output.Finally, you can deactivate the support of unknown fields by setting the :keep_unknown_fields option to false:defmodule Baz do use Protox, schema: &quot;&quot;&quot; syntax = &quot;proto3&quot;; message Sub { int32 a = 1; string b = 2; } &quot;&quot;&quot;, keep_unknown_fields: false endNote that protox will still correctly parse unknown fields, they just won't be added to the structure and you won't be able to access them.","ref":"readme.html#unknown-fields","title":"Protox - Unknown fields","type":"extras"},{"doc":"Protobuf 3 JSON mappingGroups (deprecated in protobuf)All options other than packed and default are ignored as they concern other languages implementation details.","ref":"readme.html#unsupported-features","title":"Protox - Unsupported features","type":"extras"},{"doc":"This library enforces the presence of required fields (Protobuf 2). Therefore an error is raised when encoding or decoding a message with a missing required field: defmodule Bar do use Protox, schema: &quot;&quot;&quot; syntax = &quot;proto2&quot;; message Required { required int32 a = 1; } &quot;&quot;&quot; end iex&gt; Protox.Encode.encode!(%Required{}) ** (Protox.RequiredFieldsError) Some required fields are not set: [:a] iex&gt; Required.decode!(&lt;&lt;&gt;&gt;) ** (Protox.RequiredFieldsError) Some required fields are not set: [:a]When decoding enum aliases, the last encountered constant is used. For instance, in the following example, :BAR is always used if the value 1 is read on the wire: enum E { option allow_alias = true; FOO = 0; BAZ = 1; BAR = 1; }Unset optionalsFor Protobuf 2, unset optional fields are mapped to nil. You can use the generated default/1 function to get the default value of a field: defmodule Bar do use Protox, schema: &quot;&quot;&quot; syntax = &quot;proto2&quot;; message Foo { optional int32 a = 1 [default = 42]; } &quot;&quot;&quot; end iex&gt; Foo.default(:a) {:ok, 42} iex&gt; %Foo{}.a nil It means that if you need to know if a field has been set by the sender, you just have to test if its value is nil or not.For Protobuf 3, unset optional fields are mapped to their default values, as mandated by the Protobuf spec: defmodule Bar do use Protox, schema: &quot;&quot;&quot; syntax = &quot;proto3&quot;; message Foo { int32 a = 1; } &quot;&quot;&quot; end iex&gt; Foo.default(:a) {:ok, 0} iex&gt; %Foo{}.a 0Messages and enums names: names are converted using the Macro.camelize/1 function. Thus, in the following example, non_camel_message becomes NonCamelMessage, but the field non_camel_field is left unchanged: defmodule Bar do use Protox, schema: &quot;&quot;&quot; syntax = &quot;proto3&quot;; message non_camel_message { } message CamelMessage { int32 non_camel_field = 1; } &quot;&quot;&quot; end iex&gt; msg = %NonCamelMessage{} %NonCamelMessage{__uf__: []} iex&gt; msg = %CamelMessage{} %CamelMessage{__uf__: [], non_camel_field: 0}","ref":"readme.html#implementation-choices","title":"Protox - Implementation choices","type":"extras"},{"doc":"The detailed reference of the generated code is available here.","ref":"readme.html#generated-code-reference","title":"Protox - Generated code reference","type":"extras"},{"doc":"It's also possible to generate a file that will contain all code corresponding to the protobuf messages:MIX_ENV=prod mix protox.generate --output-path=/path/to/message.ex --include-path=. test/messages.proto test/samples/proto2.protoThe --include-path option is the same as the option described in section Specify import path.The generated file will be usable in any project as long as protox is declared in the dependencies (the generated file still needs functions from the protox runtime).If you have large protobuf files, you can use the --multiple-files option to generate one file per module.mkdir generated MIX_ENV=prod mix protox.generate --multiple-files --output-path=generated --include-path=. test/messages.proto test/samples/proto2.protoDoing so, Elixir will be able to parallelize the compilation of generated modules.It is also possible to prepend a namespace to all generated modules using the --namespace option. More information is available in section Prepend namespaces.Finally, you can pass the option --keep-unknown-fields=false to remove support of unknown fields. See this section for more information.","ref":"readme.html#files-generation","title":"Protox - Files generation","type":"extras"},{"doc":"The protox library has been thoroughly tested using the conformance checker provided by Google. Note that only the binary part is tested as protox supports only this format. For instance, JSON tests are skipped.Here's how to launch the conformance test:Get conformance-test-runner sources.Compile conformance-test-runner (macOS and Linux only): tar xf v3.14.0.tar.gz &amp;&amp; cd protobuf-3.14.0 &amp;&amp; ./autogen.sh &amp;&amp; ./configure &amp;&amp; make -j &amp;&amp; cd conformance &amp;&amp; make -j.Run mix protox.conformance --runner=/path/to/protobuf-3.14.0/conformance/conformance-test-runner. A report will be generated in a directory conformance_report. If everything's fine, the following text should be displayed:CONFORMANCE TEST BEGIN ==================================== CONFORMANCE SUITE PASSED: 1302 successes, 711 skipped, 0 expected failures, 0 unexpected failures. CONFORMANCE TEST BEGIN ==================================== CONFORMANCE SUITE PASSED: 0 successes, 119 skipped, 0 expected failures, 0 unexpected failures.You can alternatively launch these conformance tests with mix test by setting the PROTOBUF_CONFORMANCE_RUNNER environment variable and including the conformance tag: PROTOBUF_CONFORMANCE_RUNNER=./protobuf-3.14.0/conformance/conformance-test-runner MIX_ENV=test mix test --include conformance","ref":"readme.html#conformance","title":"Protox - Conformance","type":"extras"},{"doc":"The following table shows how Protobuf types are mapped to Elixir's ones.ProtobufElixirint32integer()int64integer()uint32integer()uint64integer()sint32integer()sint64integer()fixed32integer()fixed64integer()sfixed32integer()sfixed64integer()floatfloat() | :infinity | :'-infinity' | :nandoublefloat() | :infinity | :'-infinity' | :nanboolboolean()stringString.t()bytesbinary()repeatedlist(value_type) where value_type is the type of the repeated fieldmapmap()oneof{atom(), value_type} where atom() is the type of the set field and where value_type is the type of the set fieldenumatom() | integer()messagestruct()","ref":"readme.html#types-mapping","title":"Protox - Types mapping","type":"extras"},{"doc":"You can launch benchmarks to see how Protox perform:mix run ./benchmarks/generate_payloads.exs # first time only, generates random payloads mix run ./benchmarks/run.exs --lib=./benchmarks/protox.exs mix run ./benchmarks/load.exs","ref":"readme.html#benchmarks","title":"Protox - Benchmarks","type":"extras"},{"doc":"Both gpb and exprotobuf were very useful in understanding how to implement Protocol Buffers.","ref":"readme.html#credits","title":"Protox - Credits","type":"extras"},{"doc":"Generated code referenceThis documentation lists the functions generated with each Elixir structure associated to a protobuf message or enum.","ref":"reference.html","title":"Generated code reference","type":"extras"},{"doc":"Encode@spec(encode(struct) :: {:ok, iodata} | {:error, any}) encode(msg)Encode msg into an iodata suitable for files or sockets. Returns {:ok, iodata} when the encoding was successful and {:error, description} in case of an encoding error.@spec(encode!(struct) :: iodata | no_return) encode!(msg)Throwing version of encode/1.Decode@spec(decode(binary) :: {:ok, struct} | {:error, any}) decode(data)Decode binary data into an structure with the type of the module on which this function is called. Returns {:ok, msg} when the decoding was successful and {:error, description} in case of an decoding error.@spec(decode!(binary) :: struct | no_return) decode!(data)Throwing version of decode/1.Syntax and definitions@spec(syntax() :: atom) syntax()Get the syntax of the protobuf message: :proto2 or :proto3.@spec defs() :: %{required(non_neg_integer) =&gt; {atom, Protox.Types.kind(), Protox.Types.type()}} defs()Get the underlying definition of a protobuf message, mostly used for internal usage. See Types section to get a description of Protox.Types.kind and Protox.Types.type.@spec %{required(atom) =&gt; {non_neg_integer, Protox.Types.kind(), Protox.Types.type()}} defs_by_name()Get the underlying definition of a protobuf message, mostly used for internal usage. See Types section to get a description of Protox.Types.kind and Protox.Types.type.Default values@spec(default(atom) :: {:ok, boolean | integer | String.t() | binary | float} | {:error, atom} default(field_name)Get the default value of a structure field. Note that for Protobuf 3, the default value is mandated by the Google reference documentation.Unknown fieldsNote: these functions are not available when the option :keep_unknown_fields is set to false.@spec clear_unknown_fields(struct) :: struct clear_unknown_fields(msg)Returns a copy of msg with all unknown fields removed.@spec unknown_fields(struct) :: [{non_neg_integer, Protox.Types.tag(), binary}] unknown_fields(msg)Get the unknown fields that may have been encountered when decoding data. See Types section to get a description of Protox.Types.tag.@spec unknown_fields_name() :: atom unknown_fields_name(msg)Get the name of the field that stores unknown fields.Required fields@spec required_fields() :: [atom] required_fields()Get the list of required fields.","ref":"reference.html#messages","title":"Generated code reference - Messages","type":"extras"},{"doc":"@spec default() :: atom default()Get the default value of an enum.@spec encode(atom) :: integer | atom encode(enum_entry)Get the integer value of an enum entry. If enum_entry does not exist in the enum, it is returned as is.@spec decode(integer) :: atom | integer decode(value)Get the enum entry of an integer value. If value does not correpond to any entry in the enum, it is returned as is.@spec constants() :: [{integer, atom}] constants()Get the list of all the constants of the enum that correponds to the module on which this function has been called.","ref":"reference.html#enums","title":"Generated code reference - Enums","type":"extras"},{"doc":"Types Protox.Types.tag, Protox.Types.kind and Protox.Types.type are defined as follows (see here for more details):@type wire_varint :: 0 @type wire_64bits :: 1 @type wire_delimited :: 2 @type wire_32bits :: 5 @type tag :: wire_varint | wire_64bits | wire_delimited | wire_32bits @type kind :: {:default, any} | :packed | :unpacked | :map | {:oneof, atom} @type map_key_type :: :int32 | :int64 | :uint32 | :uint64 | :sint32 | :sint64 | :fixed32 | :fixed64 | :sfixed32 | :sfixed64 | :bool | :string @type type :: :fixed32 | :sfixed32 | :float | :fixed64 | :sfixed64 | :double | :int32 | :uint32 | :sint32 | :int64 | :uint64 | :sint64 | :bool | :string | :bytes | {:enum, atom} | {:message, atom} | {map_key_type, type}","ref":"reference.html#types","title":"Generated code reference - Types","type":"extras"}]